import es
import beaconlib
import playerlib
import popuplib
import gamethread

info = es.AddonInfo()
info.name          = "TeamKill"
info.basename      = "teamkill"
info.version       = "1.0"
info.author        = "Adam"
info.description   = "Extensible TeamKill Punish popup menu with 14 features."

es.ServerVar(info.basename, info.version).makepublic()

removeWeaponsList = []
players = {}

def load():
    tkpunish = popuplib.create('tkpunish') 
    tkpunish.addline('[Gr] :: TkPunish')
    tkpunish.addline('--------------------')
    tkpunish.addline('->1. Forgive')
    tkpunish.addline('->2. Slay')
    tkpunish.addline('->3. Take Cash')
    tkpunish.addline('->4. Slap to 1hp')
    tkpunish.addline('->5. Burn')
    tkpunish.addline('->6. Freeze')
    tkpunish.addline('->7. Blind')
    tkpunish.addline('--------------------')
    tkpunish.addline(' ')
    tkpunish.addline('9. Next')
    tkpunish.addline('0. Cancel')
    tkpunish.menuselect = tkpunish_menuselect

    tkpunish2 = popuplib.create('tkpunish2') 
    tkpunish2.addline('[Gr] :: TkPunish')
    tkpunish2.addline('--------------------')
    tkpunish2.addline('->1. Drug')
    tkpunish2.addline('->2. Force Suicide')
    tkpunish2.addline('->3. Strip weapons')
    tkpunish2.addline('->4. Spin Round')
    tkpunish2.addline('->5. Force look at Floor')
    tkpunish2.addline('->6. Reduce speed by 5x')
    tkpunish2.addline('->7. Beacon')
    tkpunish2.addline('--------------------')
    tkpunish2.addline('8. Back')
    tkpunish2.addline(' ')
    tkpunish2.addline('0. Cancel')
    tkpunish2.menuselect = tkpunish2_menuselect

    es.msg('#multi', '#green[TeamKill] #defaultis enabled.')

def unload():
    popuplib.delete('tkpunish')
    popuplib.delete('tkpunish2')

    es.msg('#multi', '#green[TeamKill] #defaultis disabled.')

def player_disconnect(ev):
    if ev['userid'] in players:
        del players[ev['userid']]

def tkpunish_menuselect(userid, choice, popupid):
    if choice < 1 or choice > 7 and choice != 9:
        return
    userid = str(userid)
    attacker = players[userid]
    player = playerlib.getPlayer(attacker)
    if choice == 1:
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been forgiven for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 2:
        es.server.queuecmd('es_sexec %s kill' % attacker)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been slayed for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 3:
        takecash(userid)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been mugged for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 4:
        player.set("health", 1)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been slapped to 1hp for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 5:
        player.set("burn")
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been burned for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 6:
        player.set("freeze", 1)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been frozen for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 7:
        player.set("flash", (255, 1000))
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been blinded for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 9:
        popuplib.send('tkpunish2', userid)          

def tkpunish2_menuselect(userid, choice, popupid):
    if choice < 1 or choice > 8:
        return
    userid = str(userid)
    attacker = players[userid]
    player = playerlib.getPlayer(attacker)
    if choice == 1:
        es.cexec(attacker, 'r_screenoverlay effects/tp_eyefx/tp_eyefx.vmt')
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been drugged for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 2:
        player.set("push", (0, 50000, 1))
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been forced to commit suicide for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 3:
        removeWeaponsList.append(players[userid])  
        remove_weapons(players[userid])
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been stripped of all weapons for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 4:
        loop_spin(attacker)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been repeatedly spun round for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 5:
        loop_coord(attacker)
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas had view forced to floor for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 6:
        player.set("speed", (player.get("speed") * 0.2))
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas had speed reduced for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 7:
        beacon = beaconlib.EasyBeacon(attacker)
        beacon.Start()
        es.msg('#multi', '#green[TkPunish] #lightgreen"%s" #defaulthas been turned into a beacon for teamkilling #lightgreen"%s"' %(es.getplayername(attacker), es.getplayername(userid)))
    if choice == 8:
        popuplib.send('tkpunish', userid)    

def player_death(ev):
    if ev['es_userteam'] == ev['es_attackerteam']:
        victim = ev['userid']
        attacker = ev['attacker']
        if victim != attacker:
            players[victim] = attacker
            popuplib.send('tkpunish', victim)
    gamethread.cancelDelayed('loop_push(%s)' % ev['userid'])
    
def round_end(ev):
    for player in es.getUseridList():
        gamethread.cancelDelayed('loop_coord(%s)' % player)
        gamethread.cancelDelayed('loop_spin(%s)' % player)
        playerlib.getPlayer(player).set("flash", (0, 0))
        es.cexec(player, 'r_screenoverlay ""')
    del removeWeaponsList[:]

def item_pickup(ev):
    if ev['userid'] in removeWeaponsList:
        userid = ev['userid']
        gamethread.delayed(0.5, remove_weapons, userid)

def remove_weapons(attacker):
    es.server.queuecmd('es_xgive %s player_weaponstrip' % attacker)
    es.server.queuecmd('es_xfire %s player_weaponstrip Strip' % attacker)

def takecash(userid):
    victim = playerlib.getPlayer(userid)
    attacker = playerlib.getPlayer(players[userid]) 
    victim.set("cash", attacker.get("cash") + victim.get("cash"))
    if victim.get("cash") > 16000:
        victim.set("cash", 16000)
    attacker.set("cash", 0)

def loop_spin(attacker):
    yaw = es.getplayerprop(attacker, 'CCSPlayer.m_angEyeAngles[1]')
    yaw += 5
    es.server.queuecmd('es_xsetang %s 0 %s 0' %(attacker, yaw))
    gamethread.delayedname(0.00001, 'loop_spin(%s)' % attacker, loop_spin, (attacker))

def loop_coord(attacker):
    yaw = es.getplayerprop(attacker, 'CCSPlayer.m_angEyeAngles[1]')
    es.server.queuecmd('es_xsetang %s 89 %s 0' %(attacker, yaw))
    gamethread.delayedname(0.01, 'loop_coord(%s)' % attacker, loop_coord, (attacker))